# First Steps with Python: course schedule and structure

## Course schedule

* **Day 1, 9h-12h, 13h-17h:**
  * Short intro to Python and programming.
  * Intro to Jupyter Notebooks [notebook 0].
  * Python basics [notebook 1].
  * Structuring code [notebook 2].

* **Day 2, 9h-12h, 13h-17h:**
  * Structuring code [notebook 2] - continued.
  * Reading and writing files [notebook 3].

* **Day 3, 9h-12h, 13h-17h:**
  * Python modules [notebook 4].
  * Optional modules: Biopython, Pandas, Matplotlib, Numpy/Scipy
    [notebook 5-8].

**Breaks:**

* lunch break for 1h around noon.
* 15 minutes coffee breaks in the morning/afternoon. Don't hesitate to
  remind us about it if we get carried-away by our teaching!

<br>

## Course material structure

The course is taught through **Jupyter Notebooks** (you will learn all about
them at the start of the course).  
All of the course material is available on the course homepage, whose link
and login credentials you should have received via email.

Each module of the course consists of one or two notebooks that contain the
following sections:

* **Theory + Micro Exercises:**
  the first part of each notebook is composes of theory - which is presented
  in the class by the teachers - and a few "Micro Exercises".
  The "Micro Exercises" are  designed to provide short hand-on "breaks" from
  the theory and allow you to put the elements that you just learned into
  practice.  
  For each Mini Exercise section, you will be given a few minutes to work on
  your own, before we correct them together in the class.

* **Exercises:**
  following each theory session, a number of exercises will put your newly
  gained Python knowledge to the test!  
  At the end of each exercise session, corrections are done in class. We
  understand that some of you might not need these corrections, so please
  remember that now everyone in the class has the same level - doing the
  corrections together ensures that no-one gets left behind.

* **Additional Theory:**
  this section contains additional reading material that is not formally
  presented during the course. It is here so that you can optionally read
  through it, if you wish to.

* **Additional Exercises:**
  this section contains additional exercises, that are a bit more challenging
  than the regular exercises. These exercises will not be corrected in class,
  but a solution is provided.

<br>

## Detailed schedule
Please note that this schedule is approximate and might slightly change dependin on the progress
of the class.

### Day 1
* 09h00: Welcome and setup.
* 09h15: Intro to python
* 09h45: Module 0 + fix people's problems with Jupyter
* 10h15: Break
* 10h30: Module 1 - part 1 (up to string slicing, included)
* 12h00: Break
* 13h00: Module 1 - part 2
* 14h10: Exercises Module 1
* 15h00: Corrections exercises Module 1
* 15h20: Break
* 15h35: Module 2 - part 1 (up to while loops, included)
* 17h00: End of day 1

### Day 2

* 09h00: Recap
* 09h20: Module 2 - part 2 (for loop tricks, continue and break)
* 10h15: Break
* 10h30: Exercises Module 2
* 12h00: Break
* 13h00: Corrections exercises Module 2
* 13h30: Module 3
* 14h30: Exercises Module 3
* 15h30: Break
* 15h45: Corrections exercises Module 3
* 16h05: Module 4 (Import modules and using your own module)
* 17h00: End of day 2

### Day 3

* 09h00: Recap
* 09h30: Exercises Module 4
* 10h10: Corrections exercises Module 4
* 10h30: Break
* 10h50: Optional modules session 1
* 12h00: Break
* 13h00: Optional modules session 1 (continued)
* 14h15: Admin stuff (examp, feedback, etc)
* 14h30: Break
* 14h45: Optional module 2
* 17h00: End of day 3
